FROM nvidia/cuda:11.2.0-cudnn8-runtime-ubuntu20.04 as base

MAINTAINER michael.graf@uni-tuebingen.de
WORKDIR /
# Install Python and its tools
# TODO install newer python3 version and set as default
RUN apt update && apt install -y --no-install-recommends \
    git \
    build-essential \
    python3-dev \
    python3-pip \
    python3-setuptools && \
    pip3 -q install pip --upgrade # && \
    # Create python symlink for python 3
#    ln -s /usr/bin/python3 /usr/bin/python && \
#    ln -s /usr/bin/pip3 /usr/bin/pip
# Install deep learning libraries
RUN pip3 install \
    # Numpy and Pandas are required a-priori
    numpy pandas \
    # PyTorch with CUDA 10.1 support and Torchvision
    torch==1.9.0+cu111 torchvision==0.10.0+cu111 torchaudio===0.9.0 -f https://download.pytorch.org/whl/torch_stable.html \
    # Upgraded version of Tensorboard with more features
    tensorboardX \
    # tensorflow
    tensorflow

WORKDIR /opt/pht_train
COPY ./requirements.txt /tmp/requirements.txt
RUN apt-get update -yqq && \
    apt-get dist-upgrade -yqq && \
    pip install --no-cache-dir -r /tmp/requirements.txt

# install train container library
COPY ./train_lib /tmp/train-container-library/train_lib
COPY ./setup.py /tmp/train-container-library/setup.py
COPY ./README.md /tmp/train-container-library/README.md
RUN pip install --no-cache-dir /tmp/train-container-library/ && \
    rm -rf /tmp






